﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DecimalNumber
{
    public partial class Form1 : Form
    {
        private List<MySheetView> _MySheetViews = null;

        private MySpread _MySpread = null;

        public Form1()
        {
            InitializeComponent();

            _MySpread = new MySpread();

            _MySpread.ActiveSheetChanged += _MySpread_ActiveSheetChanged;

            _MySheetViews = new List<MySheetView>();

            _MySheetViews.Add(new SheetViewSpecial());

            InitializeTables();
            
            InitcomboBox1();
            
            AddOneItem();
        }

        private void DisposeHere()
        {
            if (_MySpread != null)
            {
                _MySpread.ActiveSheetChanged -= _MySpread_ActiveSheetChanged;
            }
        }

        private void InitializeTables()
        {
            ((System.ComponentModel.ISupportInitialize)(_MySpread)).BeginInit();

            foreach (MySheetView eRMSheetView in _MySheetViews)
            {
                ((System.ComponentModel.ISupportInitialize)(eRMSheetView)).BeginInit();
            }

            SuspendLayout();

            // Spread------------------
            _MySpread.AccessibleDescription = "SpreadStartup";
            _MySpread.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top
                                                                            | System.Windows.Forms.AnchorStyles.Bottom)
                                                                            | System.Windows.Forms.AnchorStyles.Left)
                                                                            | System.Windows.Forms.AnchorStyles.Right)));
            _MySpread.HorizontalScrollBarPolicy = FarPoint.Win.Spread.ScrollBarPolicy.AsNeeded;
            _MySpread.Location = new System.Drawing.Point(213, 26);
            _MySpread.Name = "Startup";
            _MySpread.SelectionBlockOptions = ((FarPoint.Win.Spread.SelectionBlockOptions)(((FarPoint.Win.Spread.SelectionBlockOptions.Rows)
                                                                                                | FarPoint.Win.Spread.SelectionBlockOptions.Sheet)));
            //_ERMSpread.SelectionBlockOptions = ((FarPoint.Win.Spread.SelectionBlockOptions)(((FarPoint.Win.Spread.SelectionBlockOptions.Cells
            //                                                                                    | FarPoint.Win.Spread.SelectionBlockOptions.Rows)
            //                                                                                    | FarPoint.Win.Spread.SelectionBlockOptions.Sheet)));
            _MySpread.Sheets.AddRange(_MySheetViews);

            _MySpread.Size = new System.Drawing.Size(1287, 524);
            _MySpread.TabIndex = 0;
            _MySpread.TabStrip.ButtonPolicy = FarPoint.Win.Spread.TabStripButtonPolicy.AsNeeded;
            _MySpread.TabStripPlacement = FarPoint.Win.Spread.TabStripPlacement.Top;
            _MySpread.TabStripPolicy = FarPoint.Win.Spread.TabStripPolicy.Always;
            _MySpread.TabStripInsertTab = false; // get rid of "New"-Tab
            _MySpread.TitleInfo.Value = "";
            _MySpread.VerticalScrollBarPolicy = FarPoint.Win.Spread.ScrollBarPolicy.AsNeeded;
            // ------------------Spread


            foreach (MySheetView eRMSheetView in _MySheetViews)
            {
                eRMSheetView.Initialize();
            }

            //// Form-------------------
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(1312, 549);
            this.Controls.Add(this._MySpread);
            //this.Name = "Form1";
            //// -------------------Form

            ((System.ComponentModel.ISupportInitialize)(_MySpread)).EndInit();

            foreach (MySheetView eRMSheetView in _MySheetViews)
            {
                ((System.ComponentModel.ISupportInitialize)(eRMSheetView)).EndInit();
            }

            this.ResumeLayout(false);
        }

        private void _MySpread_ActiveSheetChanged(object sender, EventArgs e)
        {
        }

        internal void AddOneItem()
        {
            ModelItem modelItem = new ModelItem("Hello", "Percentage", 0.5);
            ((MySheetView)_MySpread.ActiveSheet).AddModelItem(modelItem);
        }

        internal int NumberOfDigits
        {
            set
            {
                foreach (MySheetView eRMSheetView in _MySheetViews)
                {
                    eRMSheetView.NumberOfDigits = value;
                }
            }
        }

        private void InitcomboBox1()
        {
            comboBox1.Items.Clear();
            for (int i = 1; i < 6; i++)
            {
                comboBox1.Items.Add(i.ToString());
            }

            comboBox1.SelectedIndex = 1;
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            NumberOfDigits = comboBox1.SelectedIndex + 1;
        }
    }
}
