﻿using System;
using System.Collections.Generic;
using System.Text;

using FarPoint.Win.Spread.CellType;
using FarPoint.Win.Spread;

namespace DecimalNumber
{
    public class ModelItem : object
    {
        /// <summary>
        /// The name defined by a user that may not necessarilly be unique.
        /// </summary>
        public string DisplayName { get; protected set; }

        public double SomeValue { get; protected set; }
        /// <summary>
        /// The unique internal name.
        /// </summary>
        public string InternalName { get; protected set; }

        public ModelItem(string internalName, string displayName, double someValue)
        {
            InternalName = internalName;
            DisplayName = displayName;
            SomeValue = someValue;
        }

        internal void SetCellType(ref Cell cell, ECellTypes eCellType)
        {
            if (eCellType == ECellTypes.CheckBox)
            {
                cell.CellType = new CheckBoxCellType();
                cell.HorizontalAlignment = CellHorizontalAlignment.Center;
                cell.VerticalAlignment = CellVerticalAlignment.Center;
            }
            else if (eCellType == ECellTypes.ReadOnlyText)
            {
                TextCellType textCellType = new TextCellType();
                textCellType.ReadOnly = true;
                cell.CellType = textCellType;
            }
            else if (eCellType == ECellTypes.NumberAndUnit)
            {
                BaseCellType baseCellType = GetNumberUnitCellType();

                if (baseCellType == null)
                {
                    System.Diagnostics.Debug.Assert(false);
                }

                cell.CellType = baseCellType;
            }
        }

        protected NumberUnitCellType GetNumberUnitCellType()
        {
            return new NumberUnitCellType("%"); ;
        }
    }
}